class Halde:
    def __init__(self,maxLänge):
        self.maxLänge = maxLänge
        self.n = 0 # Länge der Halde
        self.a = [None]*(maxLänge+1)
         # Halde ist auf a[1] .. a[n] gespeichert.
         
    def einfügen(self,x):
        if n>=maxLänge:
            raise RuntimeError("Feldüberlauf")
        self.n += 1
        self.a[self.n] = x
        self.zuklein(n)

    def entferneMin(self):
        if self.n<=0:
            raise RuntimeError("Halde ist leer")
        x = a[1]
        self.n -= 1
        if self.n>0:
            self.a[1] = self.a[self.n+1]
            self.zugroß(1)
        return x

    def istleer(self):
        return self.n==0

    def zuklein(self, i):
        # a[i] ist möglicherweise kleiner als sein Vorgänger.
        if i==1: return
        Vorgänger = i//2
        if self.a[i]<self.a[Vorgänger]:
            self.vertausche(i,Vorgänger)
            self.zuklein(Vorgänger)

    def zugroß(self, i):
        # a[i] ist möglicherweise größer als seine Nachfolger.
        if 2*i+1 <= self.n:
            if self.a[2*i]<self.a[2*i+1]: kleinsterNachfolger = 2*i
            else:                         kleinsterNachfolger = 2*i+1
        elif 2*i <= self.n:
            kleinsterNachfolger = 2*i
        else:
            return
        if self.a[i]>self.a[kleinsterNachfolger]:
            self.vertausche(i, kleinsterNachfolger)
            zugroß(kleinsterNachfolger)

    def vertausche(self, i, j):
        self.a[i],self.a[j] = self.a[j],self.a[i]
